package com.mortals.xhx.module.biz.web;
import cn.hutool.core.codec.Base64;
import cn.hutool.core.util.IdUtil;
import com.mortals.framework.annotation.UnAuth;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.AccessLogPdu;
import com.mortals.framework.model.BizLogPdu;
import com.mortals.framework.model.OrderCol;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.common.utils.BeanUtil;
import com.mortals.xhx.system.MessageProducer;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.biz.model.BizLogEntity;
import com.mortals.xhx.module.biz.service.BizLogService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;

import java.util.*;
import java.util.stream.Collectors;
import com.alibaba.fastjson.JSONObject;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import static com.mortals.framework.ap.SysConstains.*;
/**
*
* 业务日志
*
* @author zxfei
* @date 2022-08-17
*/
@RestController
@RequestMapping("biz/log")
public class BizLogController extends BaseCRUDJsonBodyMappingController<BizLogService,BizLogEntity,Long> {
    @Autowired
    private ParamService paramService;

    @Autowired
    private MessageProducer messageProducer;

    public BizLogController(){
        super.setModuleDesc( "业务日志");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "appName", paramService.getParamBySecondOrganize("BizLog","appName"));
        super.init(model, context);
    }


    @Override
    protected void doListBefore(BizLogEntity query, Map<String, Object> model, Context context) throws AppException {
        List<OrderCol> orderColList = new ArrayList<>();
        orderColList.add(new OrderCol("id", OrderCol.DESCENDING));
        query.setOrderColList(orderColList);
        super.doListBefore(query, model, context);
    }

    @Override
    protected int viewAfter(Long id, Map<String, Object> model, BizLogEntity entity, Context context) throws AppException {
        entity.setMsg(Base64.decodeStr(entity.getMsg()));
        return super.viewAfter(id, model, entity, context);
    }

    @Override
    @UnAuth
    public String save(@RequestBody BizLogEntity entity) {
        BizLogPdu bizLogPdu = new BizLogPdu();
        bizLogPdu.initAttrValue();
        BeanUtils.copyProperties(entity, bizLogPdu, BeanUtil.getNullPropertyNames(entity));
        messageProducer.syncBizSend(bizLogPdu);
        JSONObject ret = new JSONObject();
        ret.put("code", VALUE_RESULT_SUCCESS);
        return ret.toJSONString();

       // return super.save(entity);
    }


    public static void main(String[] args) {
        System.out.println(Base64.decodeStr("eyJ3YWl0Y291bnQiOiIwIiwiZm9yd2FpdGNvdW50IjoiMCJ9"));
    }
}